# -*- coding:Utf-8 -*-


# ==================================================
# >> IMPORTATIONS
# ==================================================


import es
import gamethread

import os
import re
import configobj

import psyco
psyco.full()


# ==================================================
# >> INFORMATIONS
# ==================================================


g_informations = es.AddonInfo()
g_informations["name"] = "C4Timer by L'In20Cible"
g_informations["version"] = "1.1"
g_informations["date"] = "2010-05-17"
g_informations["author"] = "L\'in20Cible"
g_informations["url"] = "http://addons.eventscripts.com/addons/view/c4timer/"
g_informations["basename"] = "c4timer"

es.ServerVar("ct_version", (g_informations["version"] + " by " + g_informations["author"])).makepublic()


# ==================================================
# >> GLOBALES
# ==================================================


g_progress = False
mp_c4timer = es.ServerVar("mp_c4timer")
es_gamedir = str(es.ServerVar("eventscripts_gamedir"))

g_options = {
   "enable": ("1", "ct_enable <1/0> -- Active/Désactive le compte à rebours."),
   "screen": ("1", "ct_screen <1/0> -- Active/Désactive l'affichage visuel."),
   "sounds": ("1", "ct_sounds <1/0> -- Active/Désactive le compte à rebours sonore.")
   }
for option in g_options:
   g_options[option] = es.ServerVar(("ct_" + option), g_options[option][0], g_options[option][1])
   
   
# ==================================================
# >> INITIALISATION
# ==================================================


def load():
   Initialization()
   
   
def Initialization():
   global g_sounds, g_overlays
   path = GetConfigurationFilePath("configuration.cfg")
   if os.path.isfile(path):
      es.mexec(path.replace(es_gamedir, ".."))
   g_sounds = ConfigurationFileParser(GetConfigurationFilePath("sounds.ini"))
   g_overlays = ConfigurationFileParser(GetConfigurationFilePath("overlays.ini"))
   path = GetConfigurationFilePath("downloads.txt")
   if not os.path.isfile(path) or not str(es.ServerVar("eventscripts_currentmap")):
      return
   regex = re.compile("//.*|^(( |\t)+)|(( |\t)+)$|(\r)+|(\n)+")
   for line in open(path):
      line = regex.sub("", line).strip()
      if not line or not os.path.isfile(os.path.join(es_gamedir, line)):
         continue
      es.stringtable("downloadables", line)
      
      
def unload():
   if (g_progress == False):
      return
   gamethread.cancelDelayed("c4timer")
   
   
# ==================================================
# >> CLASSES
# ==================================================


class ConfigurationFileParser(configobj.ConfigObj):
   def __getitem__(self, item):
      if (item not in self):
         return ""
      return super(ConfigurationFileParser, self).__getitem__(item)
      
      
# ==================================================
# >> UTILITAIRES
# ==================================================


def GetConfigurationFilePath(file):
   return os.path.join(es_gamedir, "addons", "eventscripts", g_informations["basename"], "configuration", file).replace(os.sep, "/")
   
   
def SendC4TimerOverlay(timeleft):
   if not int(g_options["screen"]) or (str(timeleft) not in g_overlays):
      return
   for userid in es.getUseridList():
      if es.isbot(userid):
         continue
      es.cexec(userid, ("r_screenoverlay " + g_overlays[str(timeleft)]))
         
         
# ==================================================
# >> FONCTIONS D'APPEL
# ==================================================


def C4TimerLoopCallBack(timeleft):
   if (g_progress == False) or (timeleft < 0):
      return
   if int(g_options["sounds"]) and (str(timeleft) in g_sounds):
      for userid in es.getUseridList():
         if es.isbot(userid):
            continue
         es.playsound(userid, g_sounds[str(timeleft)], 1.0)
   SendC4TimerOverlay(timeleft)
   gamethread.delayedname(1, "c4timer", C4TimerLoopCallBack, (timeleft - 1))
   
   
# ==================================================
# >> ÉVÉNEMENTS
# ==================================================


def es_map_start(event_var):
   global g_progress
   Initialization()
   if (g_progress == False):
      return
   g_progress = False
   
   
def bomb_exploded(event_var):
   global g_progress
   if (g_progress == False):
      return
   g_progress = False
   SendC4TimerOverlay(0)
   
   
def bomb_defused(event_var):
   global g_progress
   if (g_progress == False):
      return
   g_progress = False
   
   
def round_start(event_var):
   global g_progress
   if (g_progress == False):
      return
   g_progress = False


def bomb_planted(event_var):
   global g_progress
   if not int(g_options["enable"]) or (g_progress == True):
      return
   g_progress = True
   C4TimerLoopCallBack(int(mp_c4timer))
   
   
def player_spawn(event_var):
   userid = int(event_var["userid"])
   if es.isbot(userid):
      return
   es.cexec(userid, "r_screenoverlay \"\"")